Subject: RE: geo short vs long term? [Re: Geo pros and cons]

From: "Bound, Jim" <[email-masked]>
Date: Thu, 3 Apr 2003 08:28:15 -0500

I suggest if a subject has consenus even appearance of that and even if
it was rehashed then just ask the list.  I felt the same as Noel but at
the IETF sat down and talked to a few of you and you have convinced me
to listen.  One thing we need to identify and note.  If anyone objects
to all ideas and builds not draft or solution or concrete roll up your
sleeves proposal then that one is suspect for success here.

My view is no decision is the worst decision.

/jim

> -----Original Message-----
> From: Iljitsch van Beijnum [mailto:[email-masked]] 
> Sent: Thursday, April 03, 2003 8:13 AM
> To: J. Noel Chiappa
> Cc: [email-masked]
> Subject: Re: geo short vs long term? [Re: Geo pros and cons]
> 
> 
> On donderdag, apr 3, 2003, at 14:37 Europe/Amsterdam, J. Noel Chiappa 
> wrote:
> 
> > Look, everyone, this is all really stupid.
> 
> > Geographic addressing has been discussed extensively about 
> 17 times in
> > the
> > IETF, and every time it has been rejected. Discussing it 
> one more time 
> > is not
> > going to change this. There is *never* going to be a rough 
> consensus 
> > *in
> > favour of* geographic addressing. There will *always* be a lot of 
> > people
> > against it - enough to stop it in the proposal stage.
> 
> If we sail too far to the west we fall off the earth and bumblebees 
> can't fly.
> 
> Since explaining it all again is unlikely to make a difference, I'll 
> just observe that none of the objections I've heard to date include a 
> part where they show "if you implement this, under reasonable 
> real-world conditions W and X, router Y will need a routing 
> table of Z 
> routes, which is too large".
> 
> 
>

---

From: "Bound, Jim" <[email-masked]>
Date: Thu, 3 Apr 2003 09:05:02 -0500

This is logical and makes sense.

But practically, if say the U.S., Mexico, and Canada all had a toplevel
GEO prefix would the connectivity issue still be real or just
theoretical?

Within this GEO if all had 2ffe then another set of bits for Mexico,
U.S. and Canada how would that exacerbate routing problems in Austrailia
or France?

Thanks
/jim

> From: J. Noel Chiappa [mailto:[email-masked]] 
> Sent: Thursday, April 03, 2003 8:35 AM
> To: [email-masked]
> Cc: [email-masked]
>     > From: "Michael H. Lambert" <[email-masked]>
> 
>     >> Geographic addressing has been discussed extensively 
> about 17 times in
>     >> the IETF, and every time it has been rejected. 
> Discussing it one more
>     >> time is not going to change this. There is *never* 
> going to be a rough
>     >> consensus *in favour of* geographic addressing. There 
> will *always* be
>     >> a lot of people against it
> 
>     > Since you have more historical context than many of us 
> on the list,
>     > could you please summarize the arguments which have 
> been used against
>     > geo? I suspect that they are mainly financial and 
> political, but there
>     > might be technical issues I'm unaware of.
> 
> Actually, I don't think that's quite correct: the argument 
> against it is in fact rooted in technical issues, although 
> there are non-technical issues in the later stages.
> 
> The analysis of geographic has been fairly well summarized in 
> recent discussion here on the list, but very simply, it goes:
> 
> - i) for the overhead of the routing to scale, the hierarchy 
> of addressing abstractions has to be reasonably closely 
> related to the actual interconnection topology;
> - ii) this means that either connectivity has to follow 
> addressing, or addressing has to follow connectivity;
> - iii) the IETF cannot mandate where connectivity gets added;
> - iv) connectivity gets put in where there are actual traffic 
> flows and/or commercial reasons to put it in.
> 
> Therefore we have to have the addressing follow the 
> connectivity, and an addressing scheme such as geographic, 
> which to scale needs to have the connectivity follow the 
> addressing, is not feasible.
> 
> 	Noel
> 
> 
> PS: Everyone, about the "this is stupid" comment - that 
> wasn't directed at anyone in particular, but at all of us, me 
> included. I suddenly had my brain start to function, and 
> realized that there is never going to be *rough consensus in 
> favour of geographic* - which is what we'd need to go forward 
> with it - and therefore further discussion thereof is not 
> useful. I hope I didn't offend anyone - if I did, my apologies.
> 
>

---

From: "Tony Li" <[email-masked]>
Date: Thu, 3 Apr 2003 12:19:22 -0800

|    But does a addressing scheme that follows connectivity AND allows 
|    multihoming to a usable degree exist?
|    
|    If yes, now would be a good time to unveil it.

Yes.

If the addressing follows connectivity and sites are multiply connected,

then they need to have multiple addresses.

Tony

---

From: "Christian Huitema" <[email-masked]>
Date: Thu, 3 Apr 2003 15:33:15 -0800

Tony,

There are a few issues with your maths. 

First, the 100% per year figure relates to the traffic growth, not the
growth in the number of hosts. The number of hosts does grow, but not
nearly as fast. The host count measured by the Internet domain survey
grew 20% last year, but that does not account for hosts behind NAT. If
you assume that the traffic growth is caused equally by larger pipes and
by more devices, then you get a growth in the number of hosts of about
40% per year.

Second, the number of sites does not grow at the same pace as the number
of hosts. For example, the number of PC per household or per office is
increasing. The hypothetical 40% host grow could be split between a
growth in the number of connected sites (new homes, new offices) and a
growth in the number of hosts per site. This would result in a 20%
yearly growth for the number of sites.

Most of the sites being added are small sites, which are the least
likely to be multihomed -- the big sites are already connected, probably
already multihomed. So, there is a strong case that the 10% figure is
probably an overstatement. But let's keep it.

The cost of maintaining the routing tables is somewhere between O(N.log
N) and O(N^2). Given the current size of 100,000 entries, a 20% increase
would correspond to an increase of 22% to 44%. 

Moore's law corresponds to an increase of about 60% yearly. 60% beats
22%, or even 44%. There is no reason to panic.

There is also no particular reason to love geographic addresses, but
that is another issue.

-- Christian Huitema

> From: Tony Li [mailto:[email-masked]]
> Sent: Thursday, April 03, 2003 12:10 PM
> To: J. Noel Chiappa; [email-masked]
> 
> 
> 
> Noel, well said.
> 
> More points: there are worse things than no decision.  That
> would be the clearly wrong decision.  We could, for example,
> choose to aggregate locators based on the lexographical
> ordering of the user's first name.  We could choose not to
> aggregate and end up with another swamp.
> 
> As to the issues with 'proving' that geo won't work, let me
> point out the very simple reasoning:
> 
> - The Internet is continually growing at an exponential rate.
>   Most people seem to peg the growth rate at 100% per year
>   currently.  The exact number is not an issue.
> 
> - In the past, we've estimated that 10% of all sites would
>   multi-home.  Let's assume a constant rate of 10% of the
>   world is an exception to the default aggregation rules
>   that we pick.
> 
> - From the above two, we can reason that our exception rate
>   is going to continue to grow exponentially.  Note that
>   the rate of absolute growth is more of an issue than the
>   exception rate.
> 
> - Moore's law for memory suggests that memory sizes will
>   double about every two years.  However, memory speeds will
>   not keep up.
> 
> - Packet lookups are a function of memory bandwidth, so to
>   sustain Internet bandwidth growth of 100% per year, we need
>   to also increase memory bandwidth by about 100% per year.
>   Using bigger, slower memories is not a realistic option.
> 
> - Thus, the routing table really needs to be constrained to
>   grow at about Moore's law for memory.
> 
> - If the exceptions are growing at about 100% per year, and
>   the memories are growing at about 100% every TWO years, then
>   regardless of the starting point, the exceptions will overtake
>   technology.
> 
> - Therefore, we must find some mechanism that prevents the
>   exceptions from growing at 100% per year.  In short, the
>   number of longer prefixes that are injected into routing
>   cannot be a constant fraction of the number of sites that
>   join.
> 
> - Since everyone and their brother will want an exception
>   for anything that they want to do that is outside of the
>   norm, the norm MUST support almost every possible situation.
>   Multihoming, in particular, must not cause exceptions.
>   Even a constant percentage of multihomers must not cause
>   exceptions.
> 
> - For reasons that I've already explained, the economics
>   of links in a geo system cause many sites to be exceptions.
> 
> - Therefore, geo addressing leads to a system that will not
>   scale for the long term.
> 
> QED
> 
> Tony
> 
> 
> |    -----Original Message-----
> |    From: J. Noel Chiappa [mailto:[email-masked]]
> |    Sent: Thursday, April 03, 2003 4:38 AM
> |    To: [email-masked]
> |    Cc: [email-masked]
> |    Subject: Re: geo short vs long term? [Re: Geo pros and cons]
> |
> |
> |    Look, everyone, this is all really stupid.
> |
> |    Geographic addressing has been discussed extensively about
> |    17 times in the
> |    IETF, and every time it has been rejected. Discussing it
> |    one more time is not
> |    going to change this. There is *never* going to be a rough
> |    consensus *in
> |    favour of* geographic addressing. There will *always* be a
> |    lot of people
> |    against it - enough to stop it in the proposal stage.
> |
> |    The really sad thing is that something productive might
> |    have been done with
> |    all this time and energy that's being wasted.
> |
> |    	Noel
> |
> |
>

---

From: "Bound, Jim" <[email-masked]>
Date: Thu, 3 Apr 2003 22:21:07 -0500

Thanks Tony no response other than your mail was key input to my
processes to think about this.  I agree about Antartica too :--)
Thank You,
/jim

>Sent: Thursday, April 03, 2003 3:18 PM
>To: Bound, Jim; J. Noel Chiappa; [email-masked]
>Subject: RE: geo short vs long term? [Re: Geo pros and cons]
>
>
>
>
>
>Jim,
>
>Yes, geo addressing at the continental level makes much more 
>sense because the connectivity within a continent is pretty much a 
>given.  Not so at the metro or lower layers, so it doesn't 
>recurse down nicely.
>
>Note that a hybrid system that was geo at the top and provider 
>based below was proposed some 10 years ago, but some folks 
>shouted it down because they didn't feel that the aggregation 
>at the continental level would have a great effect.  Of 
>course, we had very few ISPs at that exact point in time and 
>they were correct.  For the moment.
>
>I would have zero issues with continental aggregation tied
>to lower layers that were topological.  [Well, ok, I don't 
>think that Antartica should get as much as China, but that's a 
>nit. ;-) ]
>
>Tony
>
>
>|    From: Bound, Jim [mailto:[email-masked]] 
>|    Sent: Thursday, April 03, 2003 6:05 AM
>|    To: J. Noel Chiappa; [email-masked]
>|    Subject: RE: geo short vs long term? [Re: Geo pros and cons]
>|    
>|    
>|    This is logical and makes sense.
>|    
>|    But practically, if say the U.S., Mexico, and Canada all 
>|    had a toplevel
>|    GEO prefix would the connectivity issue still be real or just
>|    theoretical?
>|    
>|    Within this GEO if all had 2ffe then another set of bits 
>|    for Mexico,
>|    U.S. and Canada how would that exacerbate routing problems 
>|    in Austrailia
>|    or France?
>|    
>|    Thanks
>|    /jim
>|    
>|     
>|    
>|    
>|    > -----Original Message-----
>|    > From: J. Noel Chiappa [mailto:[email-masked]] 
>|    > Sent: Thursday, April 03, 2003 8:35 AM
>|    > To: [email-masked]
>|    > Cc: [email-masked]
>|    > Subject: Re: geo short vs long term? [Re: Geo pros and cons]
>|    > 
>|    > 
>|    >     > From: "Michael H. Lambert" <[email-masked]>
>|    > 
>|    >     >> Geographic addressing has been discussed extensively 
>|    > about 17 times in
>|    >     >> the IETF, and every time it has been rejected. 
>|    > Discussing it one more
>|    >     >> time is not going to change this. There is *never* 
>|    > going to be a rough
>|    >     >> consensus *in favour of* geographic addressing. There 
>|    > will *always* be
>|    >     >> a lot of people against it
>|    > 
>|    >     > Since you have more historical context than many of us 
>|    > on the list,
>|    >     > could you please summarize the arguments which have 
>|    > been used against
>|    >     > geo? I suspect that they are mainly financial and 
>|    > political, but there
>|    >     > might be technical issues I'm unaware of.
>|    > 
>|    > Actually, I don't think that's quite correct: the argument 
>|    > against it is in fact rooted in technical issues, although 
>|    > there are non-technical issues in the later stages.
>|    > 
>|    > The analysis of geographic has been fairly well summarized in 
>|    > recent discussion here on the list, but very simply, it goes:
>|    > 
>|    > - i) for the overhead of the routing to scale, the hierarchy 
>|    > of addressing abstractions has to be reasonably closely 
>|    > related to the actual interconnection topology;
>|    > - ii) this means that either connectivity has to follow 
>|    > addressing, or addressing has to follow connectivity;
>|    > - iii) the IETF cannot mandate where connectivity gets added;
>|    > - iv) connectivity gets put in where there are actual traffic 
>|    > flows and/or commercial reasons to put it in.
>|    > 
>|    > Therefore we have to have the addressing follow the 
>|    > connectivity, and an addressing scheme such as geographic, 
>|    > which to scale needs to have the connectivity follow the 
>|    > addressing, is not feasible.
>|    > 
>|    > 	Noel
>|    > 
>|    > 
>|    > PS: Everyone, about the "this is stupid" comment - that 
>|    > wasn't directed at anyone in particular, but at all of us, me 
>|    > included. I suddenly had my brain start to function, and 
>|    > realized that there is never going to be *rough consensus in 
>|    > favour of geographic* - which is what we'd need to go forward 
>|    > with it - and therefore further discussion thereof is not 
>|    > useful. I hope I didn't offend anyone - if I did, my apologies.
>|    > 
>|    >
>|    
>|    
>

---

From: "Tony Li" <[email-masked]>
Date: Thu, 3 Apr 2003 23:54:07 -0800

I would, without objection, like to wholly withdraw the entire
mail message that I sent and refer everyone to Noel's mail.

Please excuse my temporary insanity/stupidity.  I know better.

Tony

|    -----Original Message-----
|    From: Christian Huitema [mailto:[email-masked]] 
|    Sent: Thursday, April 03, 2003 3:33 PM
|    To: Tony Li; J. Noel Chiappa; [email-masked]
|    Subject: RE: geo short vs long term? [Re: Geo pros and cons]
|    
|    
|    Tony,
|    
|    There are a few issues with your maths. 
|    
|    First, the 100% per year figure relates to the traffic 
|    growth, not the
|    growth in the number of hosts. The number of hosts does 
|    grow, but not
|    nearly as fast. The host count measured by the Internet 
|    domain survey
|    grew 20% last year, but that does not account for hosts 
|    behind NAT. If
|    you assume that the traffic growth is caused equally by 
|    larger pipes and
|    by more devices, then you get a growth in the number of 
|    hosts of about
|    40% per year.
|    
|    Second, the number of sites does not grow at the same pace 
|    as the number
|    of hosts. For example, the number of PC per household or 
|    per office is
|    increasing. The hypothetical 40% host grow could be split between a
|    growth in the number of connected sites (new homes, new 
|    offices) and a
|    growth in the number of hosts per site. This would result in a 20%
|    yearly growth for the number of sites.
|    
|    Most of the sites being added are small sites, which are the least
|    likely to be multihomed -- the big sites are already 
|    connected, probably
|    already multihomed. So, there is a strong case that the 
|    10% figure is
|    probably an overstatement. But let's keep it.
|    
|    The cost of maintaining the routing tables is somewhere 
|    between O(N.log
|    N) and O(N^2). Given the current size of 100,000 entries, 
|    a 20% increase
|    would correspond to an increase of 22% to 44%. 
|    
|    Moore's law corresponds to an increase of about 60% 
|    yearly. 60% beats
|    22%, or even 44%. There is no reason to panic.
|    
|    There is also no particular reason to love geographic 
|    addresses, but
|    that is another issue.
|    
|    -- Christian Huitema
|    
|    > -----Original Message-----
|    > From: Tony Li [mailto:[email-masked]]
|    > Sent: Thursday, April 03, 2003 12:10 PM
|    > To: J. Noel Chiappa; [email-masked]
|    > 
|    > 
|    > 
|    > Noel, well said.
|    > 
|    > More points: there are worse things than no decision.  That
|    > would be the clearly wrong decision.  We could, for example,
|    > choose to aggregate locators based on the lexographical
|    > ordering of the user's first name.  We could choose not to
|    > aggregate and end up with another swamp.
|    > 
|    > As to the issues with 'proving' that geo won't work, let me
|    > point out the very simple reasoning:
|    > 
|    > - The Internet is continually growing at an exponential rate.
|    >   Most people seem to peg the growth rate at 100% per year
|    >   currently.  The exact number is not an issue.
|    > 
|    > - In the past, we've estimated that 10% of all sites would
|    >   multi-home.  Let's assume a constant rate of 10% of the
|    >   world is an exception to the default aggregation rules
|    >   that we pick.
|    > 
|    > - From the above two, we can reason that our exception rate
|    >   is going to continue to grow exponentially.  Note that
|    >   the rate of absolute growth is more of an issue than the
|    >   exception rate.
|    > 
|    > - Moore's law for memory suggests that memory sizes will
|    >   double about every two years.  However, memory speeds will
|    >   not keep up.
|    > 
|    > - Packet lookups are a function of memory bandwidth, so to
|    >   sustain Internet bandwidth growth of 100% per year, we need
|    >   to also increase memory bandwidth by about 100% per year.
|    >   Using bigger, slower memories is not a realistic option.
|    > 
|    > - Thus, the routing table really needs to be constrained to
|    >   grow at about Moore's law for memory.
|    > 
|    > - If the exceptions are growing at about 100% per year, and
|    >   the memories are growing at about 100% every TWO years, then
|    >   regardless of the starting point, the exceptions will overtake
|    >   technology.
|    > 
|    > - Therefore, we must find some mechanism that prevents the
|    >   exceptions from growing at 100% per year.  In short, the
|    >   number of longer prefixes that are injected into routing
|    >   cannot be a constant fraction of the number of sites that
|    >   join.
|    > 
|    > - Since everyone and their brother will want an exception
|    >   for anything that they want to do that is outside of the
|    >   norm, the norm MUST support almost every possible situation.
|    >   Multihoming, in particular, must not cause exceptions.
|    >   Even a constant percentage of multihomers must not cause
|    >   exceptions.
|    > 
|    > - For reasons that I've already explained, the economics
|    >   of links in a geo system cause many sites to be exceptions.
|    > 
|    > - Therefore, geo addressing leads to a system that will not
|    >   scale for the long term.
|    > 
|    > QED
|    > 
|    > Tony
|    > 
|    > 
|    > |    -----Original Message-----
|    > |    From: J. Noel Chiappa [mailto:[email-masked]]
|    > |    Sent: Thursday, April 03, 2003 4:38 AM
|    > |    To: [email-masked]
|    > |    Cc: [email-masked]
|    > |    Subject: Re: geo short vs long term? [Re: Geo pros and cons]
|    > |
|    > |
|    > |    Look, everyone, this is all really stupid.
|    > |
|    > |    Geographic addressing has been discussed extensively about
|    > |    17 times in the
|    > |    IETF, and every time it has been rejected. Discussing it
|    > |    one more time is not
|    > |    going to change this. There is *never* going to be a rough
|    > |    consensus *in
|    > |    favour of* geographic addressing. There will *always* be a
|    > |    lot of people
|    > |    against it - enough to stop it in the proposal stage.
|    > |
|    > |    The really sad thing is that something productive might
|    > |    have been done with
|    > |    all this time and energy that's being wasted.
|    > |
|    > |    	Noel
|    > |
|    > |
|    > 
|    
|    
|

---

From: "J. Noel Chiappa" <[email-masked]>
Date: Wed, 16 Apr 2003 11:37:38 -0400

> From: Iljitsch van Beijnum <[email-masked]>

    > Obviously I feel it would still be useful to pursue short term
    > solutions in order to buy time to develop good long term solutions

Alas, the IETF has a way of just continuing to use the interim short-turn
solutions, and never getting to the good long-term solutions.

CIDR was supposed to be an interim short-turn solution, but we're still using
it, and the routing protocols we had at the time. Running the routing in a
global-scale network as a giant distributed computation is completely crazy,
something for which you'd fail any systems architecture student who proposed
it, but we're still doing it.

	Noel

---

From: "Tony Li" <[email-masked]>
Date: Thu, 17 Apr 2003 12:18:37 -0700

|    So how would intra-site routing work? By clearing the 45 
|    routing bits 
|    when the packet arrives at the edge?

That would be one way.

Note that you can also salt the routing bits (however many we choose)
with any other constant and that will work too.  This can be used to
make it easier to migrate.  Suppose that you have a site that is
initially singly homed and already has a fixed address.  By simply
swapping the routing bits at the border router, you can now renumber
the entire site trivially.  You can also multihome, again by only
tweaking the border routers.  All local configuration can remain
the same.

|    > |    I guess it would be possible to do this without changing
|    > |    the network layer but I wouldn't bet on it.
|    
|    > I don't believe that it's a requirement to change the syntax
|    > of the network layer header.  The semantics, of course, must
|    > change.  IMHO, this is a good thing.
|    
|    Why is this good?

Because today's semantics are "locator === identifier"

|    In earlier discussions, I think we (that is, at least some of us) 
|    reached the conclusion that a 16+16 mechanism, where we 
|    have something 
|    that looks enough like a regular IPv6 unicast address to 
|    be forwarded 
|    by existing routers, would be similar in nature, but 
|    easier to deploy 
|    than 8+8 and presumably also 5.625+6.375.

Yes, but given the above argument about swapping all of the routing
bits, I'm not sure I agree.  It seems to me that a border router that
swaps just routing bits or swaps all 128 bits isn't that big a
difference.

Tony